#!/usr/bin/env python
# Copyright (c) 2010  Adam Sloboda

# useful sources and program skeleton:
# http://dannipenguin.livejournal.com/206645.html
# http://paste.lisp.org/display/68873
# http://lateral.netmanagers.com.ar/stories/BBS54.html

# known bugs:
# * keeps running after logout?
# * uses HAL

import socket

import dbus
import sys
import gobject
from dbus.mainloop.glib import DBusGMainLoop
DBusGMainLoop(set_as_default=True)

import alsaaudio
mixer = alsaaudio.Mixer('PCM')

# OSD
def update(cmd):
    sock = socket.socket()
    sock.connect(('localhost', 12321))
    sock.send(cmd)
    sock.close()

# events
def handler(sender=None, destination=None):
    if sender == 'ButtonPressed':
        if destination.startswith('brightness-'):
            level, levels = get_brightness()
            level = 100 * float(level) / (float(levels)-1)
            update('brightness %f' % level)

        elif destination == 'volume-up':
            l,r = mixer.getvolume()
            l = min(l+3,100)
            mixer.setvolume(l)
            update('volume %d' % l)
        elif destination == 'volume-down':
            l,r = mixer.getvolume()
            l = max(l-6,0)
            mixer.setvolume(l)
            update('volume %d' % l)

        #elif destination.startswith('mute'):
        #    print 'volume[muted]:', get_thinkpad_volume()
        #else:
        #    print 'received signal:', destination

# get a connection to the system bus
bus = dbus.SystemBus()

def get_brightness():
    bus = dbus.SystemBus()
    obj = bus.get_object('org.freedesktop.Hal',
                         '/org/freedesktop/Hal/devices/computer_backlight')
    iface = dbus.Interface(obj, 'org.freedesktop.Hal.Device.LaptopPanel')
    dev = dbus.Interface(obj, 'org.freedesktop.Hal.Device')
    return (iface.GetBrightness(), dev.GetProperty('laptop_panel.num_levels'))

def enum_inputs(bus):
    obj = bus.get_object('org.freedesktop.Hal', '/org/freedesktop/Hal/Manager')
    hal_manager = dbus.Interface(obj, 'org.freedesktop.Hal.Manager')
    return hal_manager.FindDeviceByCapability("input.keys")

def hook_buttons(bus):
    for udi in enum_inputs(bus):
        obj = bus.get_object('org.freedesktop.Hal', udi)
        iface = dbus.Interface(obj, 'org.freedesktop.Hal.Device')
        iface.connect_to_signal("Condition", handler)

hook_buttons(bus)

loop = gobject.MainLoop()
loop.run()
